// Code imported in the Google Maps iframe

var pgw_xul_parent=window.parent;

function pgwInitGoogle() {
  map = new GMap(document.getElementById("map"));
  map.setMapType(G_SATELLITE_TYPE);
  map.addControl(new GSmallMapControl());
  map.addControl(new GMapTypeControl());
  map.centerAndZoom(new GPoint((pgw_long_min+pgw_long_max)/2,
			       (pgw_lat_min+pgw_lat_max)/2),
		    pgw_google_init_zoom);
  GEvent.addListener(map, "move", pgwOnMove);
  GEvent.addListener(map, "click", pgwOnClick);

  pgw_xul_parent.pgw_google_iframe=window;
}

function  pgwUpdatePos(x,y) {
  map.recenterOrPanToLatLng(new GPoint(x,y));
}

function pgwOnMove() {
  var center=map.getCenterLatLng();
  window.parent.pgwUpdatePos(center.x,center.y);
}

function pgwOnClick(overlay,point) {
  pgw_xul_parent.pgwHandleClick(point.x,point.y);
}

function pgwSynchronizePos() {
  pgwUpdatePos(pgw_xul_parent.pgwGetCenterLong(),
	       pgw_xul_parent.pgwGetCenterLat());
}

function pgwCreateMarker(point, label) {
  var marker = new GMarker(point);

  GEvent.addListener(marker, "click", function() {
    marker.openInfoWindowHtml(label);
  });

  return marker;
}

function pgwDrawRoute(array_lxy) {
  var points = [];

  map.clearOverlays();

  var n=array_lxy.length;
  for (var i = 0; i<n; i++) {
    var x=array_lxy[i][1];
    var y=array_lxy[i][2];
    var label=array_lxy[i][0];
    point=new GPoint(x,y);
    points.push(point);
    var ovl=pgwCreateMarker(point, label);
    map.addOverlay(ovl);
  }

  if (n>=2) {
    var ovl=new GPolyline(points,"#60bf8f",2.0,1.0);
    map.addOverlay(ovl);
  }
}


