# -*- coding: ISO-8859-1 -*-
# Copyright (C) 2005 Christian Mauduit <ufoot@ufoot.org>

import re
import _pg

class Auth:
    """Class used to check wether one is correctly authenticated,
    and handle some basic rights."""
    def __init__(self,db,login="",passwd="",user_id=0,user_passwd=""):
        """Constructor needs a db object, plus auth information."""
        self.db=db
        self.init(login,passwd,user_id,user_passwd)
    def init(self,login="",passwd="",user_id=0,user_passwd=""):
        """Sets auth parameters, and queries the db to see if the
        user exists with this password."""
        self.user_id=0
        self.user_passwd=""
        if login and passwd:
            # Clear login/passwd (probably coming from login screen)
            query_users="SELECT user_id, user_passwd FROM pygpsweb_user WHERE user_login='%s' AND user_passwd=MD5('%s')" % (self.db.escape(login), self.db.escape(passwd))
            db_users=self.db.query_dict(query_users)
            for db_user in db_users:
                self.user_id=db_user["user_id"]
                self.user_passwd=db_user["user_passwd"]
                break
        elif user_id and user_passwd:
            # System id + md5 passwd (probably a web service called from XUL)
            query_users="SELECT user_id, user_passwd FROM pygpsweb_user WHERE user_id=%d AND user_passwd='%s'" % (int(user_id), self.db.escape(user_passwd))
            db_users=self.db.query_dict(query_users)
            for db_user in db_users:
                self.user_id=db_user["user_id"]
                self.user_passwd=db_user["user_passwd"]
                break
    def check(self):
        """Checks if one is correctly authenticated, if not, raise error."""
        if not self.can_edit():
            raise "Auth failed."
    def can_edit(self):
        """Returns true if one can edit something."""
        return self.user_id>0
    def can_edit_user(self,user_id):
        """Returns true if one can edit data belonging to a given user."""
        return self.can_edit() and self.user_id==user_id
    def can_edit_file(self,file_id):
        """Returns true if one can edit a given file."""
        # todo...
        return True
    def can_edit_point(self,file_id):
        """Returns true if one can edit a given point."""
        # todo...
        return True
    def can_edit_route(self,route_id):
        """Returns true if one can edit a given route."""
        # todo...
        return True
    def can_edit_track(self,track_id):
        """Returns true if one can edit a given track."""
        # todo...
        return True
        
        

        


