# -*- coding: ISO-8859-1 -*-
# Copyright (C) 2005 Christian Mauduit <ufoot@ufoot.org>

import common

class BrowserRdf(common.Common):
    """Handles namespace for the route RDF datasource."""
    def __init__(self,context):
        """Initialize namespace from request parameters."""
        common.Common.__init__(self,context)
        self.ns["data"]={"about":"http://www.ufoot.org/pygpsweb/browser","name":"","users":[]}
        users=context.db.query_dict("SELECT user_id, user_name FROM pygpsweb_user")
        for user_rec in users:
            user_id=user_rec["user_id"]
            tmp_user={"id":user_id,"name":user_rec["user_name"],"about":"http://www.ufoot.org/pygpsweb/browser/%d" % user_id, "files":[]}
            files=context.db.query_dict("SELECT file_id, file_name FROM pygpsweb_file WHERE file_user=%d" % user_id)
            for file_rec in files:
                file_id=file_rec["file_id"]
                tmp_file={"id":file_id,"name":file_rec["file_name"],"about":"http://www.ufoot.org/pygpsweb/browser/%d/%d" % (user_id,file_id), "types":[]}
                waypoints=context.db.query_dict("SELECT waypoint_id, waypoint_gpsid FROM pygpsweb_waypoint WHERE waypoint_file=%d" % file_id)
                if waypoints:
                    tmp_type={"id":"waypoints","name":"Waypoints","about":"http://www.ufoot.org/pygpsweb/browser/%d/%d/waypoints" % (user_id,file_id), "geoms":[]}
                    for waypoint_rec in waypoints:
                        waypoint_id=waypoint_rec["waypoint_id"]
                        tmp_waypoint={"id":file_id,"name":waypoint_rec["waypoint_gpsid"],"about":"http://www.ufoot.org/pygpsweb/browser/%d/%d/waypoints/%d" % (user_id,file_id,waypoint_id)}
                        tmp_type["geoms"].append(tmp_waypoint)
                    tmp_file["types"].append(tmp_type)
                routes=context.db.query_dict("SELECT route_id, route_gpsid FROM pygpsweb_route WHERE route_file=%d" % file_id)
                if routes:
                    tmp_type={"id":"routes","name":"Routes","about":"http://www.ufoot.org/pygpsweb/browser/%d/%d/routes" % (user_id,file_id), "geoms":[]}
                    for route_rec in routes:
                        route_id=route_rec["route_id"]
                        tmp_route={"id":file_id,"name":route_rec["route_gpsid"],"about":"http://www.ufoot.org/pygpsweb/browser/%d/%d/routes/%d" % (user_id,file_id,route_id)}
                        tmp_type["geoms"].append(tmp_route)
                    tmp_file["types"].append(tmp_type)
                tmp_user["files"].append(tmp_file)
            self.ns["data"]["users"].append(tmp_user)


