#!/bin/sh

# Script used to generate a couple of .tiff/.tfw files
# instead of a plain .tiff file. The reason is that for
# obscure reasons the NGA tiff files are unreadable by
# gdal (it's "all black")... But libgeotiff is able to 
# extract the spatial info and store it in a .tfw.
# So we use this trick and convert the .tiff to another
# .tiff using imagemagick, and then the .tiff raster
# part is readable, and the .tfw containes spatial info.

TIFF=$1

for i in $*; do
    echo $i
    listgeo -tfw $i
    mogrify -format tiff $i
done
